module CPrelude where

import Language.C.Generate

includePrelude = include "\"prelude.h\""

init, inl, inr, fst, snd, unfst, unsnd, flip, push, pop, bang, add, pushint, done, print, sub, mul :: Fun (IO ())
init  = fun $ trustMe "initialise"
inl   = fun $ trustMe "inl"
inr   = fun $ trustMe "inr"
fst   = fun $ trustMe "fst"
snd   = fun $ trustMe "snd"
unfst = fun $ trustMe "unfst"
unsnd = fun $ trustMe "unsnd"
flip  = fun $ trustMe "flip"
push  = fun $ trustMe "push"
pop   = fun $ trustMe "pop"
bang  = fun $ trustMe "bang"
add   = fun $ trustMe "add"
sub   = fun $ trustMe "sub"
mul   = fun $ trustMe "mul"
pushint = fun $ trustMe "pushint"
done  = fun $ trustMe "done"
print = fun $ trustMe "print"

match :: Fun (Fun (IO ()) -> Fun (IO ()) -> IO ())
match = fun $ trustMe "match"

integer :: Fun (Int -> IO ())
integer = fun $ trustMe "integer"

send :: Fun (Int -> Int -> IO ())
send = fun $ trustMe "send"

receive :: Fun (IO Int)
receive = fun $ trustMe "receive"

initialise :: Fun (Int -> Ptr (Ptr Char) -> IO ())
initialise = fun $ trustMe "initialise"
